import { ArenaMediatorInterface, ArenaTextInterface, ChildArena, ProtectedArenas } from '../interfaces/Arena';
import { ArenaOptionsAncestor } from '../interfaces/ArenaOptions';
import AbstractArena from './AbstractArena';
export default abstract class AbstractAncestorArena extends AbstractArena {
    readonly root: boolean;
    readonly hasParent: boolean;
    readonly hasChildren: true;
    readonly hasText: false;
    readonly inline: false;
    readonly single: false;
    readonly automerge: boolean;
    readonly group: boolean;
    readonly protected: boolean;
    readonly protectedChildren: ProtectedArenas;
    arenaForText: ArenaMediatorInterface | ArenaTextInterface;
    readonly allowedArenas: ChildArena[];
    constructor(options: ArenaOptionsAncestor);
    addAllowedChild(arena: ChildArena): void;
    setArenaForText(arena: ArenaMediatorInterface | ArenaTextInterface): void;
    getArenaForText(): ArenaMediatorInterface | ArenaTextInterface | undefined;
}
//# sourceMappingURL=AbstractAncestorArena.d.ts.map