import AbstractArena from './AbstractArena';
export default class ArenaText extends AbstractArena {
    constructor(options) {
        super(options);
        this.hasParent = true;
        this.hasChildren = false;
        this.hasText = true;
        this.inline = false;
        this.single = false;
        this.middlewares = [];
        this.nextArena = options.nextArena;
        this.getPlainProcessor = options.getPlain;
    }
    registerMiddleware(middleware) {
        this.middlewares.push(middleware);
    }
    getPlain(text, node) {
        if (this.getPlainProcessor) {
            return this.getPlainProcessor(text, node);
        }
        return text;
    }
}
//# sourceMappingURL=ArenaText.js.map