import ArenaCursor from '../interfaces/ArenaCursor';
import { AnyArenaNode } from '../interfaces/ArenaNode';
export declare type ArenaSelectionDiection = 'forward' | 'backward';
export default class ArenaSelection {
    startNode: AnyArenaNode;
    startOffset: number;
    endNode: AnyArenaNode;
    endOffset: number;
    direction: ArenaSelectionDiection;
    constructor(startNode: AnyArenaNode, startOffset: number, endNode: AnyArenaNode, endOffset: number, direction: ArenaSelectionDiection);
    clone(): ArenaSelection;
    setStartNode(startNode: AnyArenaNode, startOffset: number): ArenaSelection;
    setEndNode(endNode: AnyArenaNode, endOffset: number): ArenaSelection;
    setBoth(node: AnyArenaNode, offset: number): ArenaSelection;
    getCursor(): ArenaCursor;
    setCursor(cursor: ArenaCursor): ArenaSelection;
    getStartCursor(): ArenaCursor;
    getEndCursor(): ArenaCursor;
    isCollapsed(): boolean;
    isSameNode(): boolean;
    collapse(): ArenaSelection;
    collapseBackward(): ArenaSelection;
    trim(): ArenaSelection;
}
//# sourceMappingURL=ArenaSelection.d.ts.map