declare type CSSStyles = Partial<Omit<CSSStyleDeclaration, 'length' | 'parentRule' | 'getPropertyPriority' | 'getPropertyValue' | 'item' | 'removeProperty' | 'setProperty'>>;
declare class ElementHelper {
    private elem;
    private classes;
    private observer;
    constructor(tagName: string | HTMLElement, className?: string, innerHtml?: string);
    setClass(className: string): ElementHelper;
    addClass(className: string): ElementHelper;
    removeClass(className: string): ElementHelper;
    appendChild(node: Node | ElementHelper): ElementHelper;
    append(node: Node | ElementHelper): ElementHelper;
    css(styles: CSSStyles): ElementHelper;
    getElem(): HTMLElement;
    getInnerHTML(): string;
    setInnerHTML(html: string): ElementHelper;
    setContentEditable(enable: boolean): ElementHelper;
    onClick(handler: ((this: GlobalEventHandlers, ev: MouseEvent) => void) | null): ElementHelper;
    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => void, options?: boolean | AddEventListenerOptions): ElementHelper;
    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => void, options?: boolean | EventListenerOptions): ElementHelper;
    getBoundingClientRect(): DOMRect;
    focus(): ElementHelper;
    startObserve(callback: MutationCallback, options?: MutationObserverInit): void;
    stopObserve(): void;
    remove(): void;
}
export default ElementHelper;
//# sourceMappingURL=ElementHelper.d.ts.map