/* eslint-disable @typescript-eslint/no-explicit-any */
export default class ArenaLogger {
    constructor() {
        this.debug = false;
    }
    setDebug(debug) {
        this.debug = debug;
        return this;
    }
    log(message, ...optionalParams) {
        if (this.debug) {
            // eslint-disable-next-line no-console
            console.log(message, ...optionalParams);
        }
    }
    info(message, ...optionalParams) {
        if (this.debug) {
            // eslint-disable-next-line no-console
            console.info(message, ...optionalParams);
        }
    }
    error(message, ...optionalParams) {
        if (this.debug) {
            // eslint-disable-next-line no-console
            console.error(message, ...optionalParams);
        }
    }
    warn(message, ...optionalParams) {
        if (this.debug) {
            // eslint-disable-next-line no-console
            console.warn(message, ...optionalParams);
        }
    }
}
//# sourceMappingURL=ArenaLogger.js.map