import ArenaServiceManager from './ArenaServiceManager';
import { AnyArenaNode, ArenaNodeText } from '../interfaces/ArenaNode';
import ArenaSelection from '../helpers/ArenaSelection';
export default class ArenaParser {
    protected asm: ArenaServiceManager;
    constructor(asm: ArenaServiceManager);
    insertHtmlToRoot(htmlString: string): ArenaSelection | undefined;
    insertHtmlToModel(htmlString: string, arenaNode: AnyArenaNode, offset: number): [AnyArenaNode, number];
    private insertChildren;
    /**
     * Insert html node into some arena node.
     * @param htmlNode ChildNode from DOM
     * @param arenaNode AnyArenaNode. Current Node in the tree
     * @param offset number. Current offset in the arenaNode
     * @param firstNode boolean. If true, it was not inserted any node into arenaNode.
     * @returns [AnyArenaNode, number, boolean]. Current node, offset
     * and whether it was successfully inserted arena node.
     */
    private insertChild;
    private checkArenaMark;
    private checkFormatingMark;
    private checkAttributes;
    private getText;
    protected clearText(text: string | null, ignoreEmpty?: boolean): string;
    protected clearTextNode(textNode: ArenaNodeText): void;
    protected setAttributes(node: AnyArenaNode, element: HTMLElement): void;
}
//# sourceMappingURL=ArenaParser.d.ts.map