import ArenaBrowser from './ArenaBrowser';
import ArenaCommandManager from './ArenaCommandManager';
import ArenaHistory from './ArenaHistory';
import ArenaLogger from './ArenaLogger';
import ArenaModel from './ArenaModel';
import ArenaParser from './ArenaParser';
import ArenaView from './ArenaView';
import CreatorBar from './CreatorBar';
import EventManager from './EventManager';
import Toolbar from './Toolbar';
import SymbolCounter from './SymbolCounter';
export default class ArenaServiceManager {
    constructor(textarena) {
        this.textarena = textarena;
        this.eventManager = new EventManager(this);
        this.logger = new ArenaLogger();
        this.parser = new ArenaParser(this);
        this.model = new ArenaModel(this);
        this.browser = new ArenaBrowser(this);
        this.view = new ArenaView(this);
        this.commandManager = new ArenaCommandManager(this);
        this.toolbar = new Toolbar(this);
        this.creatorBar = new CreatorBar(this);
        this.history = new ArenaHistory(this);
        this.counter = new SymbolCounter(this);
    }
}
//# sourceMappingURL=ArenaServiceManager.js.map