import ToolbarOptions from '../interfaces/ToolbarOptions';
import ToolOptions from '../interfaces/ToolOptions';
import ElementHelper from '../helpers/ElementHelper';
import ArenaServiceManager from './ArenaServiceManager';
declare type Tool = {
    elem: ElementHelper;
    options: ToolOptions;
    modifiers?: number;
};
export default class Toolbar {
    protected asm: ArenaServiceManager;
    enabled: boolean;
    showed: boolean;
    controlKeyShowed: boolean;
    altKeyShowed: boolean;
    elem: ElementHelper;
    list: ElementHelper;
    pointer: ElementHelper;
    availableTools: {
        [key: string]: ToolOptions;
    };
    tools: Tool[];
    leftPadding: number;
    rightPadding: number;
    container: ElementHelper;
    constructor(asm: ArenaServiceManager);
    setOptions(toolbarOptions: ToolbarOptions): void;
    registerTool(opts: ToolOptions): void;
    private keyListener;
    private executeTool;
    private updateState;
    getElem(): HTMLElement;
    private show;
    private hide;
}
export {};
//# sourceMappingURL=Toolbar.d.ts.map